<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright (c) 2005, 2007 IBM Corporation and others. All rights reserved. 
	This program and the accompanying materials are made available under the 
	terms of the Eclipse Public License v1.0 which accompanies this distribution, 
	and is available at http://www.eclipse.org/legal/epl-v10.html Contributors: 
	IBM Corporation - initial implementation -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:output method="html" version="1.0" encoding="UTF-8"
		doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
		doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
		indent="yes" />

	<xsl:template match="/PublishingOption">
		<xsl:variable name="title">
			<xsl:value-of select="@title" />
		</xsl:variable>
		<html>
			<xsl:attribute name="lang"><xsl:value-of select="@lang" /></xsl:attribute>
			<xsl:attribute name="xml:lang"><xsl:value-of select="@lang" /></xsl:attribute>
			<head>
				<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE9" />
				<link rel="stylesheet" href="./css/style.css" media="screen"/>
				<link rel="stylesheet" href="./scripts/compileddojo/dijit/themes/claro/claro.css"/>
				<title>
					<xsl:value-of select="$title" />
				</title>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<meta name="meta_tagged" content="true" />
				<!-- include additional meta tags if any -->
				<xsl:for-each select="metaTags/metaTag">
					<meta>
						<xsl:attribute name="name"><xsl:value-of
							select="@name" /></xsl:attribute>
						<xsl:attribute name="content"><xsl:value-of
							select="@content" /></xsl:attribute>
					</meta>
				</xsl:for-each>
				<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1.0, maximum-scale=4,user-scalable=yes"/>
				<link type="text/css" href="skin/main.css" rel="StyleSheet" />
				<link type="text/css" href="skin/treeNodesIcons.css" rel="StyleSheet" />
				<script type="text/javascript">
	dojoConfig = {
			async: true,
			isDebug: true,
			baseUrl: '.',
			tlmSiblingOfDojo: false,
			has: {'dojo-firebug': true},
			parseOnLoad: true,
			packages: [
			{ name: "dojo", location: "scripts/compileddojo/dojo"},
			{ name: "dijit", location: "scripts/compileddojo/dijit"},
			{ name: "dojox", location: "scripts/compileddojo/dojox"},
			{ name: "theme", location: "theme"},
			{ name: "rmcwidget", location: "scripts/compileddojo/rmcwidget"}
			]
		};	
				</script>
				<script type="text/javascript" src="scripts/compileddojo/dojo/dojo.js"></script>				
			</head>
			<body class="claro">
				<div id="appLayout" data-dojo-type="dijit/layout/BorderContainer" data-dojo-props="design: 'headline'">
				<xsl:if test="@showBanner='true'">
					<!-- banner pane -->
					<div data-dojo-type="BannerWidget" data-dojo-props="region: 'top'"></div>	
				</xsl:if>
				
	<div id="navigationContainer" class = "hide"></div>
	<div id="navigationContainer" class = "show"></div>
    <div class="centerPanel" data-dojo-type="IFrameContentPane"  id="contentPanel" data-dojo-props="region: 'center'" >
		<iframe id="contentContainer" style="height: 100%; width: 100%; border: none" ></iframe>
	</div>
</div>

<!--The script below forces load and execute -->

 <script>
	require([
"theme/app"
	], function(app) {
	app.init();
	if(app.settings.showTreeBrowser == true){
	document.getElementById('navigationContainer').className = 'show';
	}
	else {
	document.getElementById('navigationContainer').className = 'hide';
	}
	});
</script>

			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
